<?php
	
	class CKRD_Cookiehint {
		
		function request_files_template(){
			
			global $wpdb;
			$tablename          = $wpdb->prefix."cookiehint_parameters";
			$result             = $wpdb->get_results("SELECT html_php_code FROM ".$tablename, ARRAY_A);
			$tmp_name           = strval($result[0]['html_php_code']);
			$php_html_code_file = 'templates/code/'.$tmp_name.'.php';
			
			return $php_html_code_file;
		}
		
		function cookiehint_add_css(){
			
			global $wpdb;
			$tablename = $wpdb->prefix."cookiehint_parameters";
			$result    = $wpdb->get_results("SELECT css_style FROM ".$tablename, ARRAY_A);
			$tmp_name  = strval($result[0]['css_style']);
			$css_style_file = 'templates/style/'.$tmp_name.'.css';
			
			return $css_style_file;
		}
		
		function remove_cookie(){
			
			unset($_COOKIE['cookiehint']);
			setcookie('cookiehint', '', time() - 3600);
			session_destroy();
			
			$this->cookieblocker_modus();
			
			$current_uri = $this->current_uri_wp();
			header("Location: $current_uri");
			die();
			
		}
		
		function current_uri_wp(){
			global $wp;
			$current_uri = home_url( $wp->request );
			return $current_uri;
		}
		
		function cookiehint_paramscheck($v){
			
			switch($v){
				case 0:
					cookiehint_popup_activation();
					break;
				case 1:
					$_SESSION["cookiehintsession"] = 1;
					$this->cookieblocker_modus();
					break;
				case 2:
					$this->modus_cookie();
					break;
				case 3:
					$this->remove_cookie();
					break;
				case 4:
					$test_modus = 1;
					cookiehint_popup_activation();					
					break;
				
			}
			
		}
		
		function getVAR($name, $value = false){
			
			if(isset($_REQUEST[$name])){
				if(!empty($_REQUEST[$name])){
					$value = sanitize_text_field($_REQUEST[$name]);
				}
			}
			
			return $value;
		}
		
		function position_popup(){
			
			global $wpdb;
			$tablename    = $wpdb->prefix."cookiehint_parameters";
			$result       = $wpdb->get_results("SELECT position,datenschutzlink,impressumlink FROM ".$tablename, ARRAY_A);
			$position     = 0;
			$tmp_page_uri = $this->current_uri_wp();
			
			
			if(strpos($tmp_page_uri, $result[0]['impressumlink']) !== false || strpos($tmp_page_uri, $result[0]['datenschutzlink']) !== false){
				$position = "bottom";
			}else{
				switch($result[0]['position']){
					case 0:
						$position = "modal";
						break;
					case 1:
						$position = "top";
						break;
					case 2:
						$position = "bottom";
						break;
				}
			}
			
			return $position;
		}
		
		function headers_params(){
			
			global $wpdb;
			$tablename        = $wpdb->prefix."cookiehint_parameters";
			$result           = $wpdb->get_results("SELECT content_security_policy FROM ".$tablename, ARRAY_A);
			$header_statement = "default-src 'self' 'unsafe-inline'";
			
			if(isset($result[0]['content_security_policy']) && !empty($result[0]['content_security_policy'])){
				$header_statement = $result[0]['content_security_policy'];
			}
			
			return $header_statement;
		}
		
		function block_cookies(){
			
			$tmp = $this->headers_params();

			@header('Content-Security-Policy: '.$tmp);
			@header('X-Content-Security-Policy: '.$tmp);
			@header('X-WebKit-CSP: '.$tmp);
			
			
		}
		
		function cookieblocker_modus(){
			
			global $wpdb;
			$tablename = $wpdb->prefix."cookiehint_parameters";
			$result    = $wpdb->get_results("SELECT cookieblocker FROM ".$tablename, ARRAY_A);
			
			switch($result[0]['cookieblocker']){
				case 0:
					break;
				case 1:
					$this->getHeadJava();
					break;
				case 2:
					$this->getHeadJava();
					$this->block_cookies();
					break;
			}
		}
		
		function refusal_btn(){
			
			global $wpdb;
			$tablename = $wpdb->prefix."cookiehint_parameters";
			$result    = $wpdb->get_results("SELECT ablehnung_options,ablehnung_redirect FROM ".$tablename, ARRAY_A);
			$refusal   = [];
			
			
			switch($result[0]['ablehnung_options']){
				case 0:
					$refusal[1] = 0;
					break;
				case 1:
					$refusal[1] = 1;
					break;
				case 2:
					$refusal[1] = 2;
					$refusal[2] = $result[0]['ablehnung_redirect'];
					break;
			}
			
			
			return $refusal;
		}
		
		
		function linkimprint(){
			
			global $wpdb;
			$tablename = $wpdb->prefix."cookiehint_parameters";
			$result    = $wpdb->get_results("SELECT impressumlink FROM ".$tablename, ARRAY_A);
			
			return $result[0]['impressumlink'];
		}
		
		function linkprivacypolicy(){
			
			global $wpdb;
			$tablename = $wpdb->prefix."cookiehint_parameters";
			$result    = $wpdb->get_results("SELECT datenschutzlink FROM ".$tablename, ARRAY_A);
			
			return $result[0]['datenschutzlink'];
		}
		
		function modus_cookie(){
			
			global $wpdb;
			$tablename = $wpdb->prefix."cookiehint_parameters";
			$result    = $wpdb->get_results("SELECT modus,tage_modus FROM ".$tablename, ARRAY_A);
			
			switch($result[0]['modus']){
				case 1:
					$tv = $this->time_cookie($result[0]['tage_modus']);
					
					setcookie("cookiehint", "2", time() + $tv);
					
					break;
				case 2:
					setcookie("cookiehint", "2", 0);
					break;
			}
			
		}
		
		
		function time_cookie($days_time){
			
			if($days_time < 0){
				#### Default 30 days
				$days_time = 2592000;
			}else{
				$days_time = $days_time * 24 * 60 * 60;
			}
			
			return $days_time;
		}
		
		
		function getHeadJava($disableCookies = 1, $disableLocal = 1, $disableSession = 1){
			
			ob_start();
			?>
			(function(){
			function blockCookies(disableCookies, disableLocal, disableSession){
			if(disableCookies == 1){
			if(!document.__defineGetter__){
			Object.defineProperty(document, 'cookie',{
			get: function(){ return ''; },
			set: function(){ return true;}
			});
			}else{
			var oldSetter = document.__lookupSetter__('cookie');
			if(oldSetter) {
			Object.defineProperty(document, 'cookie', {
			get: function(){ return ''; },
			set: function(v){
			if(v.match(/reDimCookieHint\=/)) {
			oldSetter.call(document, v);
			}
			return true;
			}
			});
			}
			}
			var cookies = document.cookie.split(';');
			for (var i = 0; i < cookies.length; i++) {
			var cookie = cookies[i];
			var pos = cookie.indexOf('=');
			var name = '';
			if(pos > -1){
			name = cookie.substr(0, pos);
			}else{
			name = cookie;
			}
			if(name.match(/reDimCookieHint/)) {
			document.cookie = name + '=; expires=Thu, 01 Jan 1970 00:00:00 GMT';
			}
			}
			}
			if(disableLocal == 1){
			window.localStorage.clear();
			window.localStorage.__proto__ = Object.create(window.Storage.prototype);
			window.localStorage.__proto__.setItem = function(){ return undefined; };
			}
			if(disableSession == 1){
			window.sessionStorage.clear();
			window.sessionStorage.__proto__ = Object.create(window.Storage.prototype);
			window.sessionStorage.__proto__.setItem = function(){ return undefined; };
			}
			}
			blockCookies(<?PHP esc_html_e($disableCookies); ?>,<?PHP esc_html_e($disableLocal); ?>,<?PHP esc_html_e($disableSession); ?>);
			}());
			<?PHP
			return str_replace(["\n", "\r", "\t", "    "], ' ', ob_get_clean());
			
		}
		
	}
